﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.ICD
<link href="~/Script/summernote/summernote.css" rel="stylesheet" />
<style>
    .note-toolbar .btn-group, .note-toolbar .btn-group .btn {
        width: inherit !important;
    }
</style>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        })
    })
</script>
<script>
        $(document).ready(function () {
        debugger
        $("#btnsubmit").show();
        if ($("#Id").val() > 0) {
            $(".titile_heading h1").html("Edit CONTROL");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
        }
        else {
            $(".titile_heading h1").html("CONTROL list");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
        //var ControlCategoryArray = JSON.parse($('#ControlCategoryIds').val());
        //$.each(ControlCategoryArray, function (i, data) {
        //    //alert(data);
        //    $("#ControlCategoryId").find("option[value=" + data + "]").prop("selected", "selected");
        //});
        $('select[name=CountryId]').val([@ViewBag.country]).change();
        $('select[name=SectorId]').val([@ViewBag.SectorId]).change();
        $('select[name=ThreatId]').val([@ViewBag.Threat]).change();
        $('select[name=ControlCategoryId]').val([@ViewBag.Category]).change();
        $('select[name=ControlTypeId]').val([@ViewBag.Control]).change();
        $('select[name=StandardIds]').val([@ViewBag.StandardIds]).change();
    });

</script>
<form asp-formhelper="true" asp-action="SubmitICD" asp-controller="IntregratedControl"
      data-ajax="true"
      data-ajax-method="POST"
      data-ajax-mode="replace"
      data-loading-text="loading......"
      data-ajax-update="#ajaxresult"
      data-ajax-success="fn_Onsuccess(data,'Master/IntregratedControl/Index');"
      data-ajax-failure="Errmsg(data);" id="Threatform" method="post">
    <input type="hidden" name="Id" id="Id" value="@Model.Id" />
    <input type="hidden" name="EventType" id="EventType" value="1" />
    <input type="hidden" name="ICDCategoryMapXML" id="ICDCategoryMapXML" value="@Model.ICDCategoryMapXML" />
    <input type="hidden" name="ICDStandardMapXML" id="ICDStandardMapXML" value="@Model.ICDStandardMapXML" />
    <input type="hidden" name="ICDArtefactMapXML" id="ICDArtefactMapXML" value="@Model.ICDArtefactMapXML" />
    <input type="hidden" name="ICDThreatMapXML" id="ICDThreatMapXML" value="@Model.ICDThreatMapXML" />
    <input type="hidden" name="ICDRegulationMapXML" id="ICDRegulationMapXML" value="@Model.ICDRegulationMapXML" />
    <input type="hidden" name="CountryIds" id="CountryIds" value="@Model.CountryIds" />
    <input type="hidden" name="SectorIds" id="SectorIds" value="@Model.SectorIds" />
    <div class="pb-2 mt-4 mb-2 border-bottom box_title">
        Domain
    </div>
    <div class="row">
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Domain</label>
            <div class="select_box m_bottom">
                <select class="form-control m_no" name="DomainId" id="DomainId" onchange="GetSubDomain(this)" required>
                    <option value="">Select Domain</option>
                    @foreach (var item in Model.DdlDomain)
                    {
                        if (item.Value == Model.DomainId.ToString())
                        {
                            <option value="@item.Value" selected>@item.Text</option>
                        }
                        else
                        {
                            <option value="@item.Value">@item.Text</option>
                        }
                    }
                </select>
            </div>
        </div>
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Sub Domain</label>
            <div class="select_box m_bottom">
                <select class="form-control m_no" name="SubDomainId" id="SubDomain" required onchange="fn_getVal(this)">
                    <option value="">Select SubDomain</option>
                    @foreach (var item in Model.Domainlist.Where(x => x.DomainId == Model.DomainId))
                    {
                        if (item.Id == Model.SubDomainId)
                        {
                            <option value="@item.Id" selected>@item.SubDomain</option>
                        }
                        else
                        {
                            <option value="@item.Id">@item.SubDomain</option>
                        }
                    }
                </select>
            </div>
        </div>
    </div>
    <div class="pb-2 mt-4 mb-2 border-bottom box_title">
        Control
    </div>
    <div class="row">
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Control Id</label>
            <div class="select_box m_bottom">
                @Html.TextBoxFor(m => m.ControlId, new { @class = "form-control-plaintext", required = "required", @readOnly = "readOnly", placeholder = "Control Id" })
            </div>
        </div>
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Name</label>
            <div class="select_box m_bottom">
                @Html.TextBoxFor(m => m.ControlName, new { @class = "form-control", required = "required", placeHolder = "Enter control name" })
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Description</label>
            <div class="select_box m_bottom">
                @Html.TextAreaFor(m => m.ControlDescription, new { @class = "form-control", required = "required", placeholder = "Enter description" })
            </div>
        </div>
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Category</label>
            <div class="select_box m_bottom">
                @Html.DropDownListFor(x => x.ControlCategoryId, Model.DdlControlCategory, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Control Type</label>
            <div class="select_box m_bottom">
                @Html.DropDownListFor(x => x.ControlTypeId, Model.DdlControlType, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
            </div>
            <label>Standards</label>
            <div class="select_box m_bottom">
                @Html.DropDownListFor(x => x.StandardIds, Model.DdlInternationalStandard, "Select Standards", new { @class = "form-control m_no", onchange = "getVersionByStandardId()" })
            </div>
        </div>
        <div class="col-md-8 col-sm-6 col-xs-12">
            <div class="table_control">
                <table id="tblVersion" class="table">
                    <thead>
                        <tr>
                            <th>Select</th>
                            <th>SNo</th>
                            <th>Service</th>
                            <th>Standards</th>
                        </tr>
                    </thead>
                    <tbody>
                        @{int sn2 = 0; }
                        @if (Model.VersionMapList.Count > 0)
                        {
                            sn2++;
                            foreach (var item in Model.VersionMapList)
                            {
                                <tr>
                                    <td><input type='checkbox' class='VersoinId' value="@item.VersoinId" /></td>
                                    <td>@sn2</td>
                                    <td>@item.Service</td>
                                    <td>@item.VersionName</td>
                                </tr>
                            }
                        }
                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <div class="pb-2 mt-4 mb-2 border-bottom box_title">
        Artefacts Required
    </div>
    <div id="multiRowDiv" class="addmultiName">
        @{int i = 0;
            foreach (var item in Model.Artefactlist)
            {
                <div class="row addRemoveDiv">
                    <div class="col-md-4 col-sm-6 col-xs-12">
                        <label>Name</label>
                        <div class="select_box m_bottom">
                            <input type="hidden" id="ArtefactId@(i)" value="@item.Id" />
                            <input class="form-control Artefacts" value="@item.Name" />
                        </div>
                    </div>
                    @if (i == 0)
                    {
                        <div class="col-2">
                            <label class="addbtn" onclick="AddMoreRow()" style="cursor:pointer"></label>
                        </div>
                    }
                    else
                    {
                        <div class="col-2">
                            <label class="remvbtn" onclick="RemoveRow(this)" style="cursor:pointer"></label>
                        </div>
                    }
                </div>
                i++;
            }
        }
    </div>
    <div class="pb-2 mt-4 mb-2 border-bottom">
    </div>
    <div class="row">
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Threat</label>
            <div class="select_box m_bottom">
                @Html.DropDownListFor(x => x.ThreatId, Model.DdlThreat, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
            </div>
        </div>
    </div>
    <div class="pb-2 mt-4 mb-2 border-bottom box_title">
        Cloud Delivery
    </div>
    <div class="row">
        <div class="col-2">
            <label>Cloud Delivery</label>
            <div class="select_box input_rembg m_bottom">
                <input type="text" class="form-control" name="IaaS" id="IaaS" value="IaaS" readonly />
                <input type="text" class="form-control" name="PaaS" id="PaaS" value="PaaS" readonly />
                <input type="text" class="form-control" name="SaaS" id="SaaS" value="SaaS" readonly />
            </div>
        </div>
        @{
            var intA1 = Model.IaaS.Split(",").Select(int.Parse).ToArray();
            var intA2 = Model.PaaS.Split(",").Select(int.Parse).ToArray();
            var intA3 = Array.ConvertAll(Model.SaaS.Split(","), int.Parse);
        }
        <div class="col-2">
            <label>Cloud Consumer</label>
            <div class="select_box select_check m_bottom">
                <input type="checkbox" class="form-control CloudCheckbox" value="1" @(intA1[0] > 0 ? "checked" : "") />
                <input type="checkbox" class="form-control CloudCheckbox" value="1" @(intA2[0] > 0 ? "checked" : "") />
                <input type="checkbox" class="form-control CloudCheckbox" value="1" @(intA3[0] > 0 ? "checked" : "") />
            </div>
        </div>
        <div class="col-2">
            <label>Service Provider</label>
            <div class="select_box select_check m_bottom">
                <input type="checkbox" class="form-control CloudCheckbox" value="2" @(intA1[1] > 0 ? "checked" : "") />
                <input type="checkbox" class="form-control CloudCheckbox" value="2" @(intA2[1] > 0 ? "checked" : "") />
                <input type="checkbox" class="form-control CloudCheckbox" value="2" @(intA3[1] > 0 ? "checked" : "") />
            </div>
        </div>
    </div>
    <div class="pb-2 mt-4 mb-2 border-bottom box_title">
        Regulation
    </div>
    <div class="row">
        <div class="col-md-4 col-sm-6 col-xs-12">
            <label>Country</label>
            <div class="select_box m_bottom">
                @Html.DropDownListFor(x => x.CountryId, Model.DdlCountry, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation()" })
            </div>
            <label>Sector</label>
            <div class="select_box m_bottom">
                @Html.DropDownListFor(x => x.SectorId, Model.DdlSector, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @onchange = "fn_GetRegulation()" })
            </div>
        </div>
        <div class="col-md-8 col-sm-6 col-xs-12">
            <div class="table_control">
                <table id="MixRegulation" class="table">
                    <thead>
                        <tr>
                            <th>Select</th>
                            <th>SNo</th>
                            <th>Country</th>
                            <th>Sector</th>
                            <th>Regulation</th>
                            <th>RequirementId</th>
                        </tr>
                    </thead>
                    <tbody>
                        @{int sn = 0; }
                        @if (Model.RegulationMapList.Count > 0)
                        {
                            sn++;
                            foreach (var item in Model.RegulationMapList)
                            {
                                <tr>
                                    <td><input type='checkbox' class='RegulationId' value="@item.RegulationId" /></td>
                                    <td>@sn</td>
                                    <td>@item.CountryName</td>
                                    <td>@item.SectorName</td>
                                    <td>@item.RegulationName</td>
                                    <td>@item.Requirement_ID</td>
                                </tr>
                            }
                        }
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12 col-sm-6 col-xs-12">
            <div class="back_btn" id="viewbutton">
                <div class="back_btn_in" data-title="Back">
                    <input type="button" name="Back" onclick="BackButton()" value="Back">
                </div>
            </div>
            <div class="submitbtn">
                <input type="submit" id="btnsubmit" name="Submit" value="Update" onclick="fnSetMultiselectValue()">
            </div>
        </div>
    </div>
</form>
<script type="text/javascript">
    function fn_Search() {
        var Country = $("#s_CountryId").val();
        var type = $("#s_TypeId").val();
        var Section = $("#s_Section").val();
        var Sector = $("#s_Sector").val();
        var Regulation = $("#s_Regulation").val();
        $.ajax({
            type: "GET",
            url: "/Master/REGO/Index",
            data: jQuery.param({
                Country: $("#s_CountryId").val(),
                type: $("#s_TypeId").val(),
                Section: $("#s_Section").val(),
                Sector: $("#s_Sector").val(),
                Regulation: $("#s_Regulation").val()
            }),
            //dataType: "json",
            //contentType: "application/json",
            success: function (data) {
                $("#ajaxresult").html(data);
                $("#s_CountryId").val(Country);
                $("#s_TypeId").val(type);
                $("#s_Section").val(Section);
                $("#s_Sector").val(Sector);
                $("#s_Regulation").val(Regulation);
                //$.each(res, function (data, value) {

                //    $("#Regulation").append($("<option></option>").val(value.id).html(value.title));
                //})
            }
        });

    }
    function AddButton() {
        $(".titile_heading h1").html("Add CONTROL");
        $(".service_line").addClass("active");
        $(".assign_panel").hide();
        //$(".titile_heading").show();}
    }
    function BackButton() {
        $('a[href="/Master/IntregratedControl/Index"]').click();
        //$(".titile_heading h1").html("CONTROL List");
        //$(".service_line").removeClass("active");
        //$(".assign_panel").show();
    }
    function fn_GetRegulation() {
        if ($("#SectorId").val() != null && $("#CountryId").val() != null) {
            $("#MixRegulation tbody").empty();
            // $("#MixRegulation ul").append($("<option></option>").val(0).html("Select"));
            $.ajax({
                type: "GET",
                url: "/Master/Regulation/GetSectorCountryWiseRegulation",
                data: jQuery.param({ SectorId: $("#SectorId").val().toString().replace("multiselect-all", ""), CountryId: $("#CountryId").val().toString().replace("multiselect-all", "") }),
                dataType: "json",
                contentType: "application/json",
                success: function (res) {
                    $.each(res, function (data, value) {

                        //  $("#MixRegulation").append($("<li></li>").id(value.id).html(value.title));
                        $("#MixRegulation tbody").append(


                            "<tr>" +
                            "<td>" + "<input type='checkbox' class='RegulationId' value=" + value.regoId + "/>" + "</td>" +
                            "<td>" + (data + 1) + "</td>" +
                            "<td>" + value.countryName + "</td>" +
                            "<td>" + value.sectorName + "</td>" +
                            "<td>" + value.regulationName + "</td>" +
                            "<td>" + value.requirement_ID + "</td>" +
                            "</tr>"

                        );
                    })
                }

            });
        }
    }

    function getVersionByStandardId() {
        if ($("#StandardId").val() != '') {
            $("#tblVersion tbody").empty();
            $.ajax({
                type: "GET",
                url: "/Master/InternationalStandard/GetVersionByStandardId",
                data: jQuery.param({ standardId: parseInt($("#StandardId").val()) }),
                dataType: "json",
                contentType: "application/json",
                success: function (res) {
                    $.each(res, function (i, v) {
                        $("#tblVersion tbody").append(
                            "<tr>" +
                            "<td>" + "<input type='checkbox' class='VersoinId' value=" + v.childISOId + "/>" + "</td>" +
                            "<td>" + (i + 1) + "</td>" +
                            "<td>" + v.service + "</td>" +
                            "<td>" + v.title + "</td>" +
                            "</tr>"
                        );
                    })
                }

            });
        }
    }
    function GetSubDomain(domain) {
        $.get('/Master/Domain/GetSubDomainByDomainId', { DomainId: parseInt($(domain).val()) }, function (data) {
            $('#SubDomain').html('');
            $('#SubDomain').append('<option value="">Select SubDomain</option>');
            $.each(data, function (i, value) {
                $('#SubDomain').append('<option value="' + value.id + '">' + value.subDomain + '</option>');
            });
        });
    }
    function fn_getVal(subDomain) {
        $.ajax({
            url: "/master/IntregratedControl/CodeById",
            type: "POST",
            cache: false,
            data: { DomainId: $("select#DomainId option:selected").val(), SubDomain: $("select#SubDomain option:selected").text() },
            success: function (result) {
                var code = result.returnMessage;
                $.ajax({
                    url: "/master/IntregratedControl/ControlById",
                    type: "POST",
                    cache: false,
                    data: { DomainId: $("select#DomainId option:selected").val(), SubDomainId: $("select#SubDomain option:selected").val() },
                    success: function (res) {
                        $("input[name=ControlId]").val(code + "-" + (res.returnMessage == null ? 1 : parseInt(res.returnMessage) + 1));
                    },
                    error: function (ex) {
                        console.log(ex.responseText);
                    }
                })
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        });
    }
    function AddMoreRow() {
        var i = $('#multiRowDiv').children('div').length;
        $('#multiRowDiv').append('<div class="row addRemoveDiv">' +
            '<div class="col-md-4 col-sm-6 col-xs-12">' +
            '<label>Name</label>' +
            '<div class="select_box m_bottom">' +
            '<input class="form-control Artefacts" />' +
            '</div></div>' +
            '<div class="col-2">' +
            '<label class="remvbtn" onclick="RemoveRow(this)" style="cursor:pointer"></label>' +
            '</div></div>');
    }
    function RemoveRow(div) {
        $(div).parent('div').eq(0).parent('div').remove();
    }
    function fnSetMultiselectValue() {
        event.preventDefault();
        var ICDCategoryMapXML = [], ICDControlTypeMapXML = [], ICDVersionMapXML = [], ICDThreatMapXML = [],
            ICDRegulationMapXML = [], ICDArtefactMapXML = [], CountryIds = [], SectorIds = [], IaaS = [], PaaS = [], SaaS = [];
        $('#ControlCategoryId option:selected').each(function (i) {
            if ($(this).val() == 'multiselect-all') {
                return;
            }
            ICDCategoryMapXML[i] = {
                Id: 0,
                CategoryId: parseInt($(this).val())
            }
        });
        $('#ICDCategoryMapXML').val(JSON.stringify(ICDCategoryMapXML));

        $('#ControlTypeId option:selected').each(function (i) {
            if ($(this).val() == 'multiselect-all') {
                return;
            }
            ICDControlTypeMapXML[i] = {
                Id: 0,
                ControlTypeId: parseInt($(this).val())
            }
        });
        $('#ICDControlTypeMapXML').val(JSON.stringify(ICDControlTypeMapXML));

        $('.VersoinId:checked').each(function (i) {
            ICDVersionMapXML[i] = {
                Id: 0,
                VersoinId: parseInt($(this).attr("value"))
            }
        });
        $('#ICDVersionMapXML').val(JSON.stringify(ICDVersionMapXML));

        $('#ThreatId option:selected').each(function (i) {
            if ($(this).val() == 'multiselect-all') {
                return;
            }
            ICDThreatMapXML[i] = {
                Id: 0,
                ThreatId: parseInt($(this).val())
            }
        });
        $('#ICDThreatMapXML').val(JSON.stringify(ICDThreatMapXML));

        $('.RegulationId:checked').each(function (i) {
            ICDRegulationMapXML[i] = {
                Id: 0,
                RegulationId: parseInt($(this).attr("value"))
            }
        });
        $('#ICDRegulationMapXML').val(JSON.stringify(ICDRegulationMapXML));

        $('.Artefacts').each(function (i, v) {
            ICDArtefactMapXML[i] = {
                Id: 0,
                Name: $(this).val()
            }
        });
        $('input[name="ICDArtefactMapXML"]').val(JSON.stringify(ICDArtefactMapXML));

        $('#CountryId option:selected').each(function (i) {
            if ($(this).val() == 'multiselect-all') {
                return;
            }
            CountryIds.push($(this).val());
        });
        $('#CountryIds').val(CountryIds);

        $('#SectorId option:selected').each(function (i) {
            if ($(this).val() == 'multiselect-all') {
                return;
            }
            SectorIds.push($(this).val());
        });
        $('#SectorIds').val(SectorIds);

        $('.CloudCheckbox').each(function (i) {
            if ($(this).index() == 0 || $(this).index() == 3) {
                IaaS.push($(this).prop("checked") ? $(this).attr("value") : 0);
            } else if ($(this).index() == 1 || $(this).index() == 4) {
                PaaS.push($(this).prop("checked") ? $(this).attr("value") : 0);
            } else if ($(this).index() == 2 || $(this).index() == 5) {
                SaaS.push($(this).prop("checked") ? $(this).attr("value") : 0);
            }
        });
        $('#IaaS').val(IaaS);
        $('#PaaS').val(PaaS);
        $('#SaaS').val(SaaS);
        $('form').submit();
    }
</script>

<script src="~/Script/summernote/summernote.js"></script>
<script src="~/Script/Master/Layout.js"></script>
<script>
    $('#Text').summernote({
        height: 100,                 // set editor height
        minHeight: null,             // set minimum height of editor
        maxHeight: null,             // set maximum height of editor
        // focus: true,
        toolbar: [
            // [groupName, [list of button]]
            ['style', ['bold', 'italic', 'underline', 'clear']],
            ['font', ['strikethrough', 'superscript', 'subscript']],
            ['fontsize', ['fontsize']],
            ['color', ['color']],
            ['para', ['ul', 'ol', 'paragraph']],
            ['height', ['height']]
        ]// set focus to editable area after initializing summernote                // set focus to editable area after initializing summernote
    });
</script>

